import { __extends } from "tslib";
import * as React from 'react';
import * as common from 'relative-time-component';
export * from 'relative-time-component';
/**
 * @public
 */
var RelativeTime = /** @class */ (function (_super) {
    __extends(RelativeTime, _super);
    function RelativeTime() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.isHovering = false;
        return _this;
    }
    Object.defineProperty(RelativeTime.prototype, "relativeTime", {
        get: function () {
            return common.getRelativeTime(this.props.time, this.props.locale);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RelativeTime.prototype, "title", {
        get: function () {
            return common.format(this.props.time);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RelativeTime.prototype, "timeText", {
        get: function () {
            return this.isHovering ? this.title : this.relativeTime;
        },
        enumerable: false,
        configurable: true
    });
    RelativeTime.prototype.UNSAFE_componentWillMount = function () {
        var _this = this;
        this.timer = setInterval(function () {
            _this.forceUpdate();
        }, 60 * 1000);
    };
    RelativeTime.prototype.componentWillUnmount = function () {
        if (this.timer) {
            clearInterval(this.timer);
        }
    };
    RelativeTime.prototype.render = function () {
        var _this = this;
        return (React.createElement("span", { title: this.title, onMouseEnter: function () { return _this.mouseenter(); }, onMouseLeave: function () { return _this.mouseleave(); } }, this.timeText));
    };
    RelativeTime.prototype.mouseenter = function () {
        this.isHovering = true;
        this.setState({ isHovering: this.isHovering });
    };
    RelativeTime.prototype.mouseleave = function () {
        this.isHovering = false;
        this.setState({ isHovering: this.isHovering });
    };
    return RelativeTime;
}(React.PureComponent));
export { RelativeTime };
